//+------------------------------------------------------------------+
//|            Gonjhik_Expert.mq4        |
//|              Copyright  2011, Gonjhik |
//|       vadim-poloskov@mail.ru    |
//|  .             icq 645824838             |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Gonjhik"
#property link      "http://satatas.awap.ru"
#include <stderror.mqh>

/*
          .
       .
  .
        .
   .
\    
\      .
    ..
*/

extern int magic=1111; // 
extern int magic2=2222; // 
extern double tp=100; //   
extern double step=50; //  
extern double order.minus=-70; //  -75  
extern double order.minus2=-20; //  -20     +5 
extern double order2.tp=5; //   
extern double order2.sl=-50;// -50
extern int    pause=10; //10 ,   
extern double order1.lot=0.1; //  
extern double order2.lot=0.2; // 
extern double order3.lot=0.3; // 
extern bool   trailing.use=true; //  ?
extern double trailing.start=50;//  +50
extern double trailing.stop=30; //     30 
extern double trailing.step=1;//1 pips

datetime tm;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   tm=0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(IsTradeContextBusy()) return (0);// , 
   
   int orders[6],orders2[6],all,all2,ticket,ticket2,type;
   string n=Symbol();
   double open,stop,take;
   color cl;
   double p=d(n)*dPoint(n);
   all=order.OrdersTotal(n,magic,orders);
   all2=order.OrdersTotal(n,magic2,orders2);
   int last.ticket=get.last.OrderTicket(n,magic,-1,MODE_HISTORY);
   
   if(all==0){
   
      datetime last.tm=order.OrderCloseTime(last.ticket,MODE_HISTORY);   
      if(last.tm==0 || (TimeCurrent()-last.tm>=pause*60)){
         Print(" ");
   /*
    1.
1)   1.1300     .     bay   .
   .
2) C       ,     bay stop  sell stop   50    ,
    100 .-         50 
3)    sell   
4)  50     30 
5)               .
   */      
         double bid=dBid(n);
         open=dAsk(n)+step*p;
         stop=0;
         take=open+tp*p;
         order.OrderSend(n,magic,OP_BUYSTOP,order1.lot,open,stop,take);
         open=dBid(n)-step*p;
         take=open-tp*p;
         order.OrderSend(n,magic,OP_SELLSTOP,order1.lot,open,stop,take);
         
         tm=TimeCurrent();
         return (0);
         }
         
   }
   
   if(all==2 && orders[OP_BUY]+orders[OP_SELL]==1 && trailing.use && all2==0){
        trailing2(n,magic,trailing.start*d(n),trailing.stop*d(n),trailing.step,-1);                  
        //trailing2(n,magic2,trailing.start*d(n),trailing.stop*d(n),trailing.step,-1);                  
   }
   
   if(all==1 && (orders[OP_BUY]+orders[OP_SELL]==0 || all2>0)){
      Print("     ");
      order.OrderCloseAll(n,magic,-1); // 
      order.OrderCloseAll(n,magic2,-1); // 
      tm=TimeCurrent();
   }
   
   double  pt=0,pt2=0;
   if(all==2 && all2==1){
      /*
       3.
   2.
5)     bay    bay stop .
6)    bay stop      sell.
7)   20     bay (        ) - .
8)    2.
      */
      if(orders2[OP_BUY]==1 && orders[OP_BUY]==1){
         ticket=get.last.OrderTicket(n,magic,OP_BUY,MODE_TRADES);
         ticket2=get.last.OrderTicket(n,magic2,OP_BUY,MODE_TRADES);
         pt=get.profitByTicket(ticket,MODE_TRADES);      
         pt2=get.profitByTicket(ticket2,MODE_TRADES);      
         if(pt<=order.minus2 && pt2>=order2.tp) {
            Print("   : ",pt2);
            order.OrderClose(ticket2,-1);
            tm=TimeCurrent();
            return (0);
         }
         
         if(pt2<=order2.sl){
            Print("  2  ");
            order.OrderSend(n,magic2,OP_SELL,order3.lot,-1,0,0);
            tm=TimeCurrent();
            return (0);
         }
         
      }
      
      if(orders2[OP_SELL]==1 && orders[OP_SELL]==1){
         ticket=get.last.OrderTicket(n,magic,OP_SELL,MODE_TRADES);
         ticket2=get.last.OrderTicket(n,magic2,OP_SELL,MODE_TRADES);
         pt=get.profitByTicket(ticket,MODE_TRADES);      
         pt2=get.profitByTicket(ticket2,MODE_TRADES);   
         if(pt<=order.minus2 && pt2>=order2.tp) {
            Print("   : ",pt2);
            order.OrderClose(ticket2,-1);
            tm=TimeCurrent();
            return (0);
         }
         
         if(pt2<=order2.sl){
            Print("  2  ");
            order.OrderSend(n,magic2,OP_BUY,order3.lot,-1,0,0);
            tm=TimeCurrent();
            return (0);
         }
         
         
      }
      
   }
   if(all==2 && all2==0){
      /*
       2.
   1.
3)     sell stop         bay.
4)  75     bay      .
5)    bay    bay stop.
6)             bay stop.
      */
      

      if(orders[OP_BUY]==1 && orders2[OP_SELL]==0){
         ticket=get.last.OrderTicket(n,magic,OP_BUY,MODE_TRADES);
         pt=get.profitByTicket(ticket,MODE_TRADES);      
         if(pt<=order.minus) {
            Print("   ");
            order.OrderSend(n,magic2,OP_SELL,order2.lot,-1,0,0);
            tm=TimeCurrent();
            return (0);
         }
         
      }
      // 2
      if(orders[OP_SELL]==1 && orders2[OP_BUY]==0){
         ticket=get.last.OrderTicket(n,magic,OP_SELL,MODE_TRADES);
         pt=get.profitByTicket(ticket,MODE_TRADES);      
         
         if(pt<=order.minus) {
            Print("   ");
            order.OrderSend(n,magic2,OP_BUY,order2.lot,-1,0,0);
            tm=TimeCurrent();
            return (0);
         }
         
         
      }
      
   }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+

void trailing2(string name,int magic,int ryn_TrStart,int ryn_TrStop,int ryn_TrStep,int type=-1){
          
          
   for(int i=OrdersTotal();i>=0;i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderMagicNumber()==magic && OrderSymbol()==name && (OrderType()==type || type==-1))
            {
               double p=dPoint(name);
               if(OrderType()==OP_BUY){
                  if(ND(dBid(name)-OrderOpenPrice())>=ND(ryn_TrStart*p)) {
                  
                        if (OrderStopLoss()<ND(dBid(name)-(ryn_TrStop+ryn_TrStep-1.0)*p) || OrderStopLoss()==0){
                           order.OrderModify(OrderTicket(),-1,ND(dBid(name)-ryn_TrStop*p),-1,0,Green);
                        }
                    }
                 }
     
               if(OrderType()==OP_SELL){
                    if(ND(OrderOpenPrice()-dAsk(name))>=ND(ryn_TrStart*p)) {
                    
                        if(OrderStopLoss()>ND(dAsk(name)+(ryn_TrStop+ryn_TrStep-1.0)*p) || OrderStopLoss()==0){
                           order.OrderModify(OrderTicket(),-1,ND(dAsk(name)+ryn_TrStop*p),-1,0,Green);
                        }
                        
                    }
                 }

            }
      }
   }  
}

int order.OrderSend(string name,int magic,int cmd,double lot,double open,double stop,double take,string comment="",datetime dt=0,color cl=CLR_NONE,bool ecn=true){
   bool is_open=true;   
   string info="";
   int j=0;
   int digit=MarketInfo(name,MODE_DIGITS);
   int ticket=-1;
   
   if(open==-1){
      if(cmd==OP_BUY){RefreshRates(); open=MarketInfo(name,MODE_ASK); }
      if(cmd==OP_SELL){RefreshRates(); open=MarketInfo(name,MODE_BID); }
   }
   
   while(is_open && j<20){
      j++;
      if(ecn){
         if(ticket==-1) ticket=OrderSend(name,cmd,lot,NormalizeDouble(open,digit),0,0,0,comment,magic,dt,cl);      
         if(ticket!=-1 && (take>0.0 || stop>0.0)) OrderModify(ticket,NormalizeDouble(open,digit),NormalizeDouble(stop,digit),NormalizeDouble(take,digit),dt);
      }else{
         if(ticket==-1) ticket=OrderSend(name,cmd,lot,NormalizeDouble(open,digit),0,NormalizeDouble(stop,digit),NormalizeDouble(take,digit),comment,magic,dt,cl);      
      }
      int err=GetLastError();

      if(ticket==-1 || err>0){
         info=StringConcatenate("order.OrderSend(",name,",",cmd,",",lot,",",open,",",stop,",",take,",",comment,")");
         is_open=print.Error(err,j,info);
         if(cmd==OP_BUY){RefreshRates(); open=MarketInfo(name,MODE_ASK); }
         if(cmd==OP_SELL){RefreshRates(); open=MarketInfo(name,MODE_BID); }
      }else{
         is_open=false;
         break;
      }
 
   }
   
   return (ticket);
}


bool print.Error(int err,int j,string informer="",int pause=5000){
   bool is_open=true;
   
   switch(err){
         case ERR_NO_ERROR:
         case ERR_NO_RESULT: 
         case ERR_COMMON_ERROR:{is_open=false; break;}      
         case ERR_BROKER_BUSY: {Print(" ,  "+DoubleToStr(j,0)); Sleep(pause);} break;
         case ERR_SERVER_BUSY: {Print(" ,  "+DoubleToStr(j,0)); Sleep(pause);} break;
         case ERR_NO_CONNECTION: {Print("   ,  "+DoubleToStr(j,0)); Sleep(pause);} break;
         case ERR_TRADE_TIMEOUT: {Print("    ,  "+DoubleToStr(j,0)); Sleep(pause);} break;
         case ERR_PRICE_CHANGED: {Print(" ,  "+DoubleToStr(j,0)+" "+informer); Sleep(pause);} break;
         case ERR_REQUOTE: {Print(",  "+DoubleToStr(j,0)+" "+informer); Sleep(pause);} break;
         case ERR_TOO_FREQUENT_REQUESTS: {Print("  ,  "+DoubleToStr(j,0)+" "+informer); Sleep(pause);} break;
         case ERR_ORDER_LOCKED: {is_open=false; Print("    ");} break;
         case ERR_INVALID_STOPS: {Print(" ,  "+DoubleToStr(j,0)+" "+informer); Sleep(pause);} break;
         case ERR_INVALID_PRICE: {Print(" (),  "+DoubleToStr(j,0)+" "+informer);} break;
         case ERR_OFF_QUOTES: {Print(" ,  "+DoubleToStr(j,0));} break;
         case ERR_INVALID_TRADE_VOLUME: {is_open=false; Print(" , "+informer);} break;
         case ERR_MARKET_CLOSED: {is_open=false; Print(" ");} break;
         case ERR_TRADE_DISABLED: {is_open=false; Print(" ");} break;
         case ERR_NOT_ENOUGH_MONEY: {is_open=false; Print("    , "+informer);} break;
         case ERR_LONG_POSITIONS_ONLY_ALLOWED: {is_open=false; Print("  ");} break;
         case ERR_TRADE_MODIFY_DENIED: {Print("     ( ),  "+DoubleToStr(j,0)+" "+informer); Sleep(pause);} break;
         case ERR_TRADE_EXPIRATION_DENIED: {is_open=false; Print("     ");} break;
         case ERR_TRADE_TOO_MANY_ORDERS: {is_open=false; Print("      ,  .");} break; 
         case ERR_TRADE_HEDGE_PROHIBITED: {is_open=false; Print("        ,   .");} break; 
         case ERR_TRADE_PROHIBITED_BY_FIFO: {is_open=false; Print("         FIFO.");} break; 
         
         case ERR_INVALID_TICKET: {is_open=false; Print("  , "+informer);} break; 
         default: {is_open=false; Print(" : "+err+" "+informer);} break;
      }
      
    return (is_open);  
}

bool order.OrderClose(int ticket,double lot,int slip=0,color cl=CLR_NONE){
   bool is_open=true;   
   int j=0;
   int digit=MarketInfo(OrderSymbol(),MODE_DIGITS);
   if(!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) return (false);
   
   if(ticket<=0) return (false);
   string info="";
   if(lot==-1) lot=OrderLots();
   double open=0;
   
   int t=OrderType();
   while(is_open && j<20){
      j++;
      RefreshRates();
      if(t==OP_BUY) open=dBid(OrderSymbol());   
      if(t==OP_SELL) open=dAsk(OrderSymbol());   
      
      if(ticket>0 && open!=0 && t<2) OrderClose(ticket,lot,NormalizeDouble(open,digit),slip,cl);
      if(ticket>0 && t>=2) OrderDelete(ticket);

      int err=GetLastError();
      
      if(err>0){
          info=StringConcatenate("order.OrderClose(",ticket,",",lot,")");
          is_open=print.Error(err,j); 
      }else{
          is_open=false;    
      }    
      
   }
   
   return (is_open);
}

bool order.OrderModify(int ticket,double open,double stop,double take,datetime dt=0,color cl=CLR_NONE){
   bool is_open=true;   
   int j=0;
   int digit=MarketInfo(OrderSymbol(),MODE_DIGITS);
   if(!OrderSelect(ticket,SELECT_BY_TICKET)) return (false);
   
   if(ticket<=0) return (false);
   double p=dPoint(OrderSymbol());
   string info="";
   if(take==-1) take=OrderTakeProfit();
   if(stop==-1) stop=OrderStopLoss();
   if(open==-1) open=OrderOpenPrice();
   
   while(is_open && j<20){
      j++;
      if(ticket>0 && (!cmp.double(open,OrderOpenPrice(),p) || !cmp.double(take,OrderTakeProfit(),p) || !cmp.double(stop,OrderStopLoss(),p)) ) OrderModify(ticket,NormalizeDouble(open,digit),NormalizeDouble(stop,digit),NormalizeDouble(take,digit),dt);
      int err=GetLastError();
      if(err>0){
          info=StringConcatenate("order.OrderModify(",ticket,",",open,",",stop,",",take,")");
          is_open=print.Error(err,j,info);
      }else{ 
          is_open=false;
      }    
      
   }
   
   return (is_open);
}

double dAsk(string name){  return (MarketInfo(name,MODE_ASK));}
double dBid(string name){  return (MarketInfo(name,MODE_BID));}
double dPoint(string name){  return (MarketInfo(name,MODE_POINT));}

double dDigits(string name){  return (MarketInfo(name,MODE_DIGITS));}
double NLot(double lot){ if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.1)  return(NormalizeDouble(lot,1));   if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.01) return(NormalizeDouble(lot,2));  return (lot);}
int d(string name=""){if(name=="") name=Symbol(); int digits=1; if(MarketInfo(name,MODE_DIGITS)==5 || MarketInfo(name,MODE_DIGITS)==3) digits=10; return (digits);}
double ND(double d,string name=""){if(name=="") name=Symbol(); return (NormalizeDouble(d,MarketInfo(name,MODE_DIGITS)));}
double ND2(double d,int dgt=-1,string name=""){ if(name=="") name=Symbol(); if(dgt>=0) return (NormalizeDouble(d,dgt)); else return (NormalizeDouble(d,MarketInfo(name,MODE_DIGITS)));}
bool cmp.double(double p1,double p2,double point){ if(MathAbs(p1-p2)>point) return (false);  return (true);}
/*
   
string name - ,
int id -  ,
int &orders[] -    6 -> int orders[6];
*/
int order.OrdersTotal(string name,int id,int &orders[]){
 
   int i,all=0;
   for(i=0;i<6;i++) orders[i]=0; // 
 
   //    
   for(i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i,SELECT_BY_POS)){   
         if((OrderSymbol()==name || name=="") && (OrderMagicNumber()==id || id==-1)){
            orders[OrderType()]++; //  
            all++;
         }
      }
   }
 
   return (all);
}

int order.OrdersTotal2(string name,int id,int period,int &orders[],int mode=MODE_TRADES){
   int i;
   int count=0;
   ArrayResize(orders,6);
   for(i=0;i<6;i++) orders[i]=0; // 
   
   i=0;
   if(mode==MODE_HISTORY) i=OrdersHistoryTotal();
   if(mode==MODE_TRADES) i=OrdersTotal();
   for(;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,mode)){
            
            if(OrderMagicNumber()==id && OrderSymbol()==name && iBarShift(name,period,OrderOpenTime())==iBarShift(name,period,TimeCurrent()) ) {
                  orders[OrderType()]++;
                  count++;
            }
      }
   }  
   
   return (count);
}

void order.OrderCloseAll(string name,int id,int type){
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(!OrderSelect(i,SELECT_BY_POS)) continue;
         
      if((OrderSymbol()==name || name=="") && (OrderMagicNumber()==id || id==-1)){
         order.OrderClose(OrderTicket(),-1);
      }
   }  
}

int get.last.OrderTicket(string name,int id,int type,int mode=MODE_TRADES){
   int i;
   if(mode==MODE_TRADES) i=OrdersTotal()-1;
   if(mode==MODE_HISTORY) i=OrdersHistoryTotal()-1;
   
   
   for(;i>=0;i--){
      if(!OrderSelect(i,SELECT_BY_POS,mode)) continue;
         
      if((OrderSymbol()==name || name=="") && (OrderMagicNumber()==id || id==-1)){
         if(OrderType()==type || type==-1) return (OrderTicket());
      }
   }
 
   return (0);
}

int order.OrderType(int ticket){
 
  if(!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) return (-1);
         
  return (OrderType());
}

datetime order.OrderCloseTime(int ticket,int mode=MODE_TRADES){
 
   if(!OrderSelect(ticket,SELECT_BY_TICKET,mode)) return (0);
   return (OrderCloseTime());
}
int StrToPeriod(string p){

   if(p=="M1" || p=="m1") return (PERIOD_M1);
   if(p=="M5" || p=="m5") return (PERIOD_M5);
   if(p=="M15" || p=="m15") return (PERIOD_M15);
   if(p=="M30" || p=="m30") return (PERIOD_M30);
   if(p=="H1" || p=="h1") return (PERIOD_H1);
   if(p=="H4" || p=="h4") return (PERIOD_H4);
   if(p=="D1" || p=="d1") return (PERIOD_D1);
   if(p=="W1" || p=="w1") return (PERIOD_W1);
   if(p=="MN1" || p=="mn1") return (PERIOD_MN1);
   
   return (0); // 
}


double get.profitByTicket(int ticket,int mode=MODE_TRADES){
   if(ticket==-1) return (0);
   
   if(!OrderSelect(ticket,SELECT_BY_TICKET,mode)) return (0);
   string n=OrderSymbol();
   double p=d(n)*dPoint(n);
   
   if(OrderType()==OP_BUY)  return ((dAsk(n)-OrderOpenPrice())/p);
   if(OrderType()==OP_SELL)  return ((OrderOpenPrice()-dBid(n))/p);
   
   return (0);
}